'1307-Blitz 10 mit Uhr-Motor (Verschlimmbesserung 1) von Heinz D.
'unter Verwendung des Gewitterwarner 2 von B. Kainka
'mit ### sind die zugefgten Zeilen markiert
'###############################################################################
'  1 /Reset/B5/Ad0
'  2 B3/Ad3              LED grn oder Motor
'  3 B4/Ad2              LED gelb oder Motor
'  4 GND
'  5 B0/mosi/oc0a        Pwm->TA7642
'  6 B1/miso/Int0/oc0b   TA7642->In
'  7 B2/Sck/Ad1/T0       LED rot und Buzzer
'  8 +Vcc
Lrot Alias Portb.2
Mot0 Alias Portb.3
Mot1 Alias Portb.4
'###############################################################################
$regfile = "attiny13.dat"
$prog &HFF , &H6A , &HFF , &H00                '9,6MHz/8=1,2MHz
$crystal = 1200000
$hwstack = 16
$swstack = 16
$framesize = 16

'Config Adc = Single , Prescaler = 2 , Reference = Avcc      ' Pre 8...32
'Start Adc
'Open "comb.1:9600,8,n,1,INVERTED" For Output As #1
'Open "comb.2:9600,8,n,1,INVERTED" For Input As #2

Config Portb = &B00011101

Config Timer0 = Pwm , Prescale = 1 , Compare A Pwm = Clear Up       'PWM B0
Start Timer0

Config Int0 = Rising                           'INT0 B1
On Int0 Isrint0
Enable Int0

Dim I As Byte
Dim Count As Word
Dim Level As Word
Dim Decay As Word
Dim Motor As Byte                              '### odd/even-Merker

Count = 0
I = 0
Lrot = 1                                       'Portb.2 = 1
Do
  I = I + 1
  Pwm0a = I
  Enable Interrupts
  Waitms 50
  Disable Interrupts
Loop Until Count > 200                         'Ub einstellen
Lrot = 0                                       'Portb.2 = 0
I = I - 50
Pwm0a = I
Wait 2
Level = 0

Do
  Count = 0
  Enable Interrupts
  Waitms 200                                   '1 s zhlen
  Disable Interrupts
  If Count > 1 Then                            'min 2 Impulse
    Level = Level + Count                      'Count

'### Uhr-Motor toggle
   If Motor = 0 Then                           '###
      Mot1 = 0                                 '###
      Mot0 = 1                                 '### gerade Sekunde
      Motor = 1                                '###
   Else                                        '###
      Mot0 = 0                                 '###
      Mot1 = 1                                 '### ungerade Sekunde
      Motor = 0                                '###
   End If                                      '###
'### optisch/akustisch
   Sound Lrot , 40 , 60                        '### WAIT
   Mot0 = 0                                    '###
   Mot1 = 0                                    '###
   Lrot = 0                                    '###

'    Portb.3 = 1                                'Blitz-LED B2
'    Waitms 20
'    Portb.3 = 0
'    Waitms 20
  End If
  Decay = Level
  Shift Decay , Right , 8
  Level = Level - Decay                        'Level nimmt ab
'  If Level < 2000 Then Portb = &B00000000
'  If Level > 2000 Then Portb = &B00001000      'grn
'  If Level > 4000 Then Portb = &B00010000      'gelb
'  If Level > 6000 Then Portb = &B00000100      'rot
Loop

Isrint0:
 Count = Count + 32                            'Software-Counter
 If Count > 250 Then Count = 250
Return

End
Data "B l i t z 1 0 - M o t o r "              'Prog-Name